
/* Ensures new hotfix field in settings */
DECLARE @settingid int
SET @settingid = ISNULL((SELECT Top 1 KeyID FROM CMS_SettingsKey WHERE KeyName = N'CMSHotfixVersion'), 0)

IF (@settingid = 0) BEGIN

INSERT INTO [CMS_SettingsKey]
           ([KeyName]
           ,[KeyDisplayName]
           ,[KeyDescription]
           ,[KeyValue]
           ,[KeyType]
           ,[KeyCategoryID]
           ,[SiteID]
           ,[KeyGUID]
           ,[KeyLastModified]
           ,[KeyOrder]
           ,[KeyDefaultValue]
           ,[KeyValidation]
           ,[KeyEditingControlPath]
           ,[KeyLoadGeneration]
           ,[KeyIsGlobal])
     VALUES
           ('CMSHotfixVersion'
           ,'Hotfix version'
           ,'Hotfix version'
           ,'0'
           ,'int'
           ,NULL
           ,NULL
           ,newId()
           ,getDate()
           ,NULL
           ,'0'
           ,NULL
           ,NULL
           ,0
           ,1)
END
GO

-- Inserting Resource strings
DECLARE @stringId AS int;
DECLARE @cultureId AS int;
DECLARE @cultureCode AS nvarchar(50);

-- Change value of this parameter if your default UI culture is not 'en-US' (see details in hotfix instructions)
SET @cultureCode = 'en-US';

-- Get culture ID
SET @cultureID = (SELECT UICultureID FROM [CMS_UICulture] WHERE UICultureCode=@cultureCode);

-- Check if resource string exists
SET @stringId = (SELECT StringID FROM [CMS_ResourceString] LEFT JOIN [CMS_ResourceTranslation] ON StringID=TranslationStringID WHERE StringKey = N'accessdenied.notallowedtocreatenewcultureversion' AND TranslationUICultureID = @cultureID);
IF  @stringId IS NULL
BEGIN
-- Insert resource string
INSERT INTO [CMS_ResourceString]
           ([StringKey]
           ,[StringIsCustom]
           ,[StringLoadGeneration])
     VALUES
           ('accessdenied.notallowedtocreatenewcultureversion'
           ,0
           ,0)

SET @stringId = scope_identity();

-- Insert translation
INSERT INTO [CMS_ResourceTranslation]
           ([TranslationStringID]
           ,[TranslationUICultureID]
           ,[TranslationText])
     VALUES
           (@stringId
           ,@cultureId
           ,'You''re not allowed to create a new culture version.')
END

-- Check if resource string exists
SET @stringId = (SELECT StringID FROM [CMS_ResourceString] LEFT JOIN [CMS_ResourceTranslation] ON StringID=TranslationStringID WHERE StringKey = N'cssstylesheet.notallowedtoedit' AND TranslationUICultureID = @cultureID);
IF  @stringId IS NULL
BEGIN
-- Insert resource string
INSERT INTO [CMS_ResourceString]
           ([StringKey]
           ,[StringIsCustom]
           ,[StringLoadGeneration])
     VALUES
           ('cssstylesheet.notallowedtoedit'
           ,0
           ,0)

SET @stringId = scope_identity();

-- Insert translation
INSERT INTO [CMS_ResourceTranslation]
           ([TranslationStringID]
           ,[TranslationUICultureID]
           ,[TranslationText])
     VALUES
           (@stringId
           ,@cultureId
           ,'You aren''t allowed to modify selected stylesheet.')
END

-- Check if resource string exists
SET @stringId = (SELECT StringID FROM [CMS_ResourceString] LEFT JOIN [CMS_ResourceTranslation] ON StringID=TranslationStringID WHERE StringKey = N'cssstylesheet.errorediting' AND TranslationUICultureID = @cultureID);
IF  @stringId IS NULL
BEGIN
-- Insert resource string
INSERT INTO [CMS_ResourceString]
           ([StringKey]
           ,[StringIsCustom]
           ,[StringLoadGeneration])
     VALUES
           ('cssstylesheet.errorediting'
           ,0
           ,0)

SET @stringId = scope_identity();

-- Insert translation
INSERT INTO [CMS_ResourceTranslation]
           ([TranslationStringID]
           ,[TranslationUICultureID]
           ,[TranslationText])
     VALUES
           (@stringId
           ,@cultureId
           ,'Error editing CSS stylesheet')
END


-- Check if resource string general.badhashtex exists
SET @stringId = (SELECT StringID FROM [CMS_ResourceString] LEFT JOIN [CMS_ResourceTranslation] ON StringID=TranslationStringID WHERE StringKey = N'SelectColumns.nocustomtablesavaible' AND TranslationUICultureID = @cultureID);
IF  @stringId IS NULL
BEGIN
-- Insert resource string
INSERT INTO [CMS_ResourceString]
           ([StringKey]
           ,[StringIsCustom]
           ,[StringLoadGeneration])
     VALUES
           ('SelectColumns.nocustomtablesavaible'
           ,0
           ,0)

SET @stringId = scope_identity();

-- Insert translation
INSERT INTO [CMS_ResourceTranslation]
           ([TranslationStringID]
           ,[TranslationUICultureID]
           ,[TranslationText])
     VALUES
           (@stringId
           ,@cultureId
           ,'No custom table avaible.')
END

-- Check if resource string definesitestructure.insertfailed exists
SET @stringId = (SELECT StringID FROM [CMS_ResourceString] LEFT JOIN [CMS_ResourceTranslation] ON StringID=TranslationStringID WHERE StringKey = N'definesitestructure.insertfailed' AND TranslationUICultureID = @cultureID);
IF  @stringId IS NULL
BEGIN
-- Insert resource string
INSERT INTO [CMS_ResourceString]
           ([StringKey]
           ,[StringIsCustom]
           ,[StringLoadGeneration])
     VALUES
           ('definesitestructure.insertfailed'
           ,0
           ,0)

SET @stringId = scope_identity();

-- Insert translation
INSERT INTO [CMS_ResourceTranslation]
           ([TranslationStringID]
           ,[TranslationUICultureID]
           ,[TranslationText])
     VALUES
           (@stringId
           ,@cultureId
           ,'Failed to insert document')
END

-- Check if resource string relationship.norelationship exists
SET @stringId = (SELECT StringID FROM [CMS_ResourceString] LEFT JOIN [CMS_ResourceTranslation] ON StringID=TranslationStringID WHERE StringKey = N'relationship.norelationship' AND TranslationUICultureID = @cultureID);
IF  @stringId IS NULL
BEGIN
-- Insert resource string
INSERT INTO [CMS_ResourceString]
           ([StringKey]
           ,[StringIsCustom]
           ,[StringLoadGeneration])
     VALUES
           ('relationship.norelationship'
           ,0
           ,0)

SET @stringId = scope_identity();

-- Insert translation
INSERT INTO [CMS_ResourceTranslation]
           ([TranslationStringID]
           ,[TranslationUICultureID]
           ,[TranslationText])
     VALUES
           (@stringId
           ,@cultureId
           ,'No relationship available for this site.')
END

-- Check if resource string definesitestructure.deletionfailed exists
SET @stringId = (SELECT StringID FROM [CMS_ResourceString] LEFT JOIN [CMS_ResourceTranslation] ON StringID=TranslationStringID WHERE StringKey = N'definesitestructure.deletionfailed' AND TranslationUICultureID = @cultureID);
IF  @stringId IS NULL
BEGIN
-- Insert resource string
INSERT INTO [CMS_ResourceString]
           ([StringKey]
           ,[StringIsCustom]
           ,[StringLoadGeneration])
     VALUES
           ('definesitestructure.deletionfailed'
           ,0
           ,0)

SET @stringId = scope_identity();

-- Insert translation
INSERT INTO [CMS_ResourceTranslation]
           ([TranslationStringID]
           ,[TranslationUICultureID]
           ,[TranslationText])
     VALUES
           (@stringId
           ,@cultureId
           ,'Failed to delete document')
END

-- Check if resource string definesitestructure.movefailed exists
SET @stringId = (SELECT StringID FROM [CMS_ResourceString] LEFT JOIN [CMS_ResourceTranslation] ON StringID=TranslationStringID WHERE StringKey = N'definesitestructure.movefailed' AND TranslationUICultureID = @cultureID);
IF  @stringId IS NULL
BEGIN
-- Insert resource string
INSERT INTO [CMS_ResourceString]
           ([StringKey]
           ,[StringIsCustom]
           ,[StringLoadGeneration])
     VALUES
           ('definesitestructure.movefailed'
           ,0
           ,0)

SET @stringId = scope_identity();

-- Insert translation
INSERT INTO [CMS_ResourceTranslation]
           ([TranslationStringID]
           ,[TranslationUICultureID]
           ,[TranslationText])
     VALUES
           (@stringId
           ,@cultureId
           ,'Failed to move document')
END

-- Check if resource string definesitestructure.updatefailed exists
SET @stringId = (SELECT StringID FROM [CMS_ResourceString] LEFT JOIN [CMS_ResourceTranslation] ON StringID=TranslationStringID WHERE StringKey = N'definesitestructure.updatefailed' AND TranslationUICultureID = @cultureID);
IF  @stringId IS NULL
BEGIN
-- Insert resource string
INSERT INTO [CMS_ResourceString]
           ([StringKey]
           ,[StringIsCustom]
           ,[StringLoadGeneration])
     VALUES
           ('definesitestructure.updatefailed'
           ,0
           ,0)

SET @stringId = scope_identity();

-- Insert translation
INSERT INTO [CMS_ResourceTranslation]
           ([TranslationStringID]
           ,[TranslationUICultureID]
           ,[TranslationText])
     VALUES
           (@stringId
           ,@cultureId
           ,'Failed to update document')
END

GO


-- Update deleting role dependencies
ALTER PROCEDURE [Proc_CMS_Role_RemoveDependences]
    @RoleID int
AS
BEGIN
    -- SET NOCOUNT ON added to prevent extra result sets from
    -- interfering with SELECT statements.
    SET NOCOUNT ON;
    
    BEGIN TRANSACTION;
    
    DELETE FROM CMS_UserRole WHERE RoleID=@RoleID;
    DELETE FROM CMS_RolePermission WHERE RoleID=@RoleID; 
    DELETE FROM CMS_ACLItem WHERE RoleID=@RoleID;
    DELETE FROM CMS_WorkflowStepRoles WHERE RoleID=@RoleID; 
    DELETE FROM Forums_ForumRoles WHERE RoleID = @RoleID;
    DELETE FROM Polls_PollRoles WHERE RoleID = @RoleID;
    DELETE FROM Media_LibraryRolePermission WHERE RoleID = @RoleID;
    DELETE FROM Community_GroupRolePermission WHERE RoleID = @RoleID;
    DELETE FROM CMS_WidgetRole WHERE RoleID = @RoleID;
    -- Message boards
    DELETE FROM Board_Role WHERE RoleID = @RoleID;
    -- UIProfiles
    DELETE FROM CMS_RoleUIElement WHERE RoleID = @RoleID;
    --Newsletters
    DELETE FROM [Newsletter_SubscriberNewsletter] WHERE [SubscriberID] IN (SELECT SubscriberID FROM Newsletter_Subscriber WHERE SubscriberType LIKE 'cms.role' AND SubscriberRelatedID = @RoleID);
    DELETE FROM [Newsletter_Emails] WHERE EmailSubscriberID IN (SELECT SubscriberID FROM Newsletter_Subscriber WHERE SubscriberType LIKE 'cms.role' AND SubscriberRelatedID = @RoleID);
    DELETE FROM [Newsletter_Subscriber] WHERE SubscriberType LIKE 'cms.role' AND SubscriberRelatedID = @RoleID;
     -- Project Management
	DELETE FROM [PM_ProjectRolePermission] WHERE RoleID = @RoleID;    
    
    COMMIT TRANSACTION;
END
GO


-- Update deleting user dependencies
ALTER PROCEDURE [Proc_CMS_User_RemoveDependences]
    @ID int
AS
BEGIN
    -- SET NOCOUNT ON added to prevent extra result sets from
    -- interfering with SELECT statements.
    SET NOCOUNT ON;
    BEGIN TRANSACTION;
    -- deletes dependencies in CMS_UserSite, CMS_UserRole and CMS_EmailUser
    DELETE FROM [CMS_UserSite] WHERE UserID=@ID;
    DELETE FROM [CMS_UserRole] WHERE UserID=@ID;
    DELETE FROM [CMS_EmailUser] WHERE UserID=@ID;
    -- delete dependencies in CMS_UserCulture
    DELETE FROM [CMS_UserCulture] WHERE UserID=@ID;
    -- delete dependencies in Forums_ForumModerators
    DELETE FROM [Forums_ForumModerators] WHERE UserID=@ID;
    -- delete dependencies in Forums_ForumSubscription
    DELETE FROM [Forums_ForumSubscription] WHERE SubscriptionUserID=@ID;
    -- updates dependencies in CMS_EventLog, CMC_Document, CMS_VersionHistory and CMS_WorkflowHistory
    UPDATE [CMS_Document] SET DocumentCreatedByUserID=NULL WHERE DocumentCreatedByUserID=@ID;
    UPDATE [CMS_Document] SET DocumentCheckedOutByUserID=NULL WHERE DocumentCheckedOutByUserID=@ID;
    UPDATE [CMS_Document] SET DocumentModifiedByUserID=NULL WHERE DocumentModifiedByUserID=@ID;
    UPDATE [CMS_EventLog] SET UserID=NULL WHERE UserID=@ID
    UPDATE CMS_VersionHistory SET ModifiedByUserID=NULL WHERE ModifiedByUserID=@ID;
    UPDATE CMS_WorkflowHistory SET ApprovedByUserID=NULL WHERE ApprovedByUserID=@ID;
    -- remove dependencies in NodeOwner
    UPDATE [CMS_Tree] SET NodeOwner=NULL WHERE NodeOwner=@ID;
    -- remove dependencies in CMS_ACLItem
    DELETE FROM CMS_ACLItem WHERE UserID = @ID;
    UPDATE CMS_ACLItem SET LastModifiedByUserID=NULL WHERE LastModifiedByUserID=@ID;
    -- update dependencies in COM_Customer, COM_OrderStatusUser, COM_ShoppingCart
    UPDATE COM_Customer SET CustomerUserID=NULL WHERE CustomerUserID=@ID;
    UPDATE COM_OrderStatusUser SET ChangedByUserID=NULL WHERE ChangedByUserID=@ID;
    UPDATE COM_ShoppingCart SET ShoppingCartUserID=NULL WHERE ShoppingCartUserID=@ID;
    -- remove dependencies in COM_UserDepartment
    DELETE FROM COM_UserDepartment WHERE UserID=@ID;
    -- remove dependencies in [COM_Wishlist]
    DELETE FROM [COM_Wishlist] WHERE UserID=@ID;
    -- set null to media file FKs
    UPDATE Media_File SET FileCreatedByUserID=NULL WHERE FileCreatedByUserID=@ID;
    UPDATE Media_File SET FileModifiedByUserID=NULL WHERE FileModifiedByUserID=@ID;
    -- set null to saved reports
    UPDATE Reporting_SavedReport SET SavedReportCreatedByUserID = NULL WHERE SavedReportCreatedByUserID=@ID
    -- set null to checkouted templates, layouts and css styles
    UPDATE CMS_PageTemplate SET PageTemplateLayoutCheckedOutByUserID = NULL WHERE PageTemplateLayoutCheckedOutByUserID = @ID;
    UPDATE CMS_Layout SET LayoutCheckedOutByUserID = NULL WHERE LayoutCheckedOutByUserID=@ID;
    UPDATE CMS_CssStyleSheet SET StylesheetCheckedOutByUserID = NULL WHERE StylesheetCheckedOutByUserID=@ID;
    -- Blog_Comment - set CommentUserID a CommentApprovedByUserID to null
    UPDATE Blog_Comment SET CommentUserID = NULL WHERE CommentUserID=@ID;
    UPDATE Blog_Comment SET CommentApprovedByUserID = NULL WHERE CommentApprovedByUserID=@ID;
    UPDATE Blog_PostSubscription SET SubscriptionUserID = NULL WHERE SubscriptionUserID=@ID;
    -- Messaging_Message - set MessageSenderUserID to null and MessageSenderDeleted to true
    UPDATE Messaging_Message SET MessageSenderUserID = NULL, MessageSenderDeleted=1 WHERE MessageSenderUserID=@ID;
    UPDATE Messaging_Message SET MessageRecipientUserID = NULL, MessageRecipientDeleted=1 WHERE MessageRecipientUserID=@ID;
    DELETE FROM Messaging_Message WHERE MessageRecipientDeleted=1 AND MessageSenderDeleted=1;
    -- ForumsPost
    UPDATE Forums_ForumPost SET PostUserID = NULL WHERE PostUserID = @ID;
    UPDATE Forums_ForumPost SET PostApprovedByUserID = NULL WHERE PostApprovedByUserID = @ID;
    -- Forum user favorites
    DELETE FROM [Forums_UserFavorites] WHERE UserID = @ID;
    -- Export history
    UPDATE Export_History SET ExportUserID = NULL
    -- Groups
    UPDATE [Community_Group] SET GroupCreatedByUserID = NULL WHERE GroupCreatedByUserID = @ID;
    UPDATE [Community_Group] SET GroupApprovedByUserID = NULL WHERE GroupApprovedByUserID = @ID;
    DELETE FROM [Community_GroupMember] WHERE MemberUserID = @ID;
    UPDATE [Community_GroupMember] SET MemberApprovedByUserID = NULL WHERE MemberApprovedByUserID = @ID;
    UPDATE [Community_GroupMember] SET MemberInvitedByUserID = NULL WHERE MemberInvitedByUserID = @ID;
    -- Notifications
    DELETE FROM Notification_Subscription WHERE SubscriptionUserID = @ID;
    -- Message boards
    DELETE Board_Moderator WHERE UserID = @ID;
    UPDATE Board_Message SET MessageUserID = NULL WHERE MessageUserID = @ID;
    UPDATE Board_Message SET MessageApprovedByUserID = NULL WHERE MessageApprovedByUserID = @ID;
    DELETE Board_Moderator WHERE UserID = @ID;
    -- User message boards
    DELETE FROM Board_Message WHERE MessageBoardID IN ( SELECT BoardID FROM Board_Board WHERE BoardUserID = @ID );
    DELETE FROM Board_Moderator WHERE BoardID IN ( SELECT BoardID FROM Board_Board WHERE BoardUserID = @ID );
    DELETE FROM Board_Role WHERE BoardID IN ( SELECT BoardID FROM Board_Board WHERE BoardUserID = @ID );        
	DELETE FROM Board_Subscription WHERE SubscriptionUserID = @ID; -- delete users subscriptions   
    DELETE FROM Board_Subscription WHERE SubscriptionBoardID IN (SELECT BoardID FROM Board_Board WHERE BoardUserID = @ID); --delete subscriptions on users boards
    DELETE FROM Board_Board WHERE BoardUserID = @ID;
    -- Abuse report
    UPDATE CMS_AbuseReport SET ReportUserID = NULL WHERE ReportUserID = @ID;
    -- Contact list
    DELETE Messaging_ContactList WHERE ContactListUserID = @ID OR ContactListContactUserID = @ID;
    -- Ignore list
    DELETE Messaging_IgnoreList WHERE IgnoreListUserID = @ID OR IgnoreListIgnoredUserID = @ID;
    -- Friends
    DELETE Community_Friend WHERE FriendRequestedUserID = @ID OR FriendUserID = @ID OR FriendApprovedBy = @ID OR FriendRejectedBy = @ID;
    -- Categories
    DELETE CMS_DocumentCategory WHERE CategoryID IN ( SELECT CategoryID FROM CMS_Category WHERE CategoryUserID = @ID );
    DELETE CMS_Category WHERE CategoryUserID = @ID;
    -- Delete user sessions
    DELETE FROM CMS_Session WHERE SessionUserID = @ID;
    -- Invitations
    DELETE FROM [Community_Invitation] WHERE InvitedUserID = @ID OR InvitedByUserID = @ID;
    -- Activated by user id
    UPDATE [CMS_UserSettings] SET UserActivatedByUserID = NULL WHERE UserActivatedByUserID = @ID;
    --Widgets
    DELETE FROM CMS_Personalization WHERE PersonalizationUserID = @ID;
    --OpenIDUser
    DELETE FROM CMS_OpenIDUser WHERE UserID = @ID;
    --Newsletters
    DELETE FROM [Newsletter_SubscriberNewsletter] WHERE [SubscriberID] IN (SELECT SubscriberID FROM Newsletter_Subscriber WHERE SubscriberType LIKE 'cms.user' AND SubscriberRelatedID = @ID);
    DELETE FROM [Newsletter_Emails] WHERE EmailSubscriberID IN (SELECT SubscriberID FROM Newsletter_Subscriber WHERE SubscriberType LIKE 'cms.user' AND SubscriberRelatedID = @ID);
    DELETE FROM [Newsletter_Subscriber] WHERE SubscriberType LIKE 'cms.user' AND SubscriberRelatedID = @ID;
	-- Project management
	UPDATE [PM_Project] SET ProjectOwner = NULL WHERE ProjectOwner = @ID;
	UPDATE [PM_Project] SET ProjectCreatedByID = NULL WHERE ProjectCreatedByID = @ID;
	UPDATE [PM_ProjectTask] SET ProjectTaskCreatedByID = NULL WHERE ProjectTaskCreatedByID = @ID;
	-- Clear OwnerID, AssignedToUserID if it is a project task
	UPDATE [PM_ProjectTask] SET ProjectTaskOwnerID = NULL WHERE (ProjectTaskOwnerID = @ID) AND (ProjectTaskProjectID IS NOT NULL);
	UPDATE [PM_ProjectTask] SET ProjectTaskAssignedToUserID = NULL WHERE (ProjectTaskAssignedToUserID = @ID) AND (ProjectTaskProjectID IS NOT NULL);
	-- Ad-hoc tasks
	UPDATE [PM_ProjectTask] SET ProjectTaskOwnerID = COALESCE(ProjectTaskCreatedByID, ProjectTaskAssignedToUserID, ProjectTaskOwnerID)
		WHERE (ProjectTaskOwnerID = @ID) AND (ProjectTaskProjectID IS NULL);
	UPDATE [PM_ProjectTask] SET ProjectTaskAssignedToUserID = COALESCE(ProjectTaskOwnerID, ProjectTaskCreatedByID, ProjectTaskAssignedToUserID)
		WHERE (ProjectTaskAssignedToUserID = @ID) AND (ProjectTaskProjectID IS NULL);
	DELETE FROM [PM_ProjectTask]
	WHERE ((ProjectTaskCreatedByID = @ID) OR (ProjectTaskCreatedByID IS NULL)) AND
		  ((ProjectTaskOwnerID = @ID) OR ProjectTaskOwnerID IS NULL) AND
		  ((ProjectTaskAssignedToUserID = @ID) OR ProjectTaskAssignedToUserID IS NULL) AND
		  (ProjectTaskProjectID IS NULL);	
    
    COMMIT TRANSACTION;
END
GO


UPDATE CMS_Query
SET QueryText = 
'SELECT * FROM CMS_ScheduledTask WHERE TaskName = @TaskName AND (TaskSiteID = @TaskSiteID OR @TaskSiteID = 0)' WHERE QueryName = N'selectByTaskName' AND ClassID = (SELECT ClassID FROM CMS_Class WHERE ClassName=N'CMS.ScheduledTask')
GO


ALTER VIEW [View_CMS_Relationship_Joined]
AS
SELECT     LeftTree.NodeID AS LeftNodeID, LeftTree.NodeGUID AS LeftNodeGUID, LeftTree.NodeName AS LeftNodeName, 
                      CMS_RelationshipName.RelationshipName, CMS_RelationshipName.RelationshipNameID, RightTree.NodeID AS RightNodeID, 
                      RightTree.NodeGUID AS RightNodeGUID, RightTree.NodeName AS RightNodeName, CMS_RelationshipName.RelationshipDisplayName, CMS_Relationship.RelationshipCustomData
FROM         CMS_Relationship INNER JOIN
                      CMS_Tree AS LeftTree ON CMS_Relationship.LeftNodeID = LeftTree.NodeID INNER JOIN
                      CMS_Tree AS RightTree ON CMS_Relationship.RightNodeID = RightTree.NodeID INNER JOIN
                      CMS_RelationshipName ON CMS_Relationship.RelationshipNameID = CMS_RelationshipName.RelationshipNameID

GO


ALTER PROCEDURE [Proc_CMS_Site_RemoveDependences] 
    @SiteID int
AS
BEGIN
    -- SET NOCOUNT ON added to prevent extra result sets from
    -- interfering with SELECT statements.
    SET NOCOUNT ON;
    -- removes VersionHistory dependences from VersionAttachment
    DELETE FROM [CMS_VersionAttachment] WHERE VersionHistoryID IN (
        SELECT VersionHistoryID FROM [CMS_VersionHistory] WHERE NodeSiteID = @SiteID
    );
    -- removes VersionHistory dependences from WorkflowHistory
    DELETE FROM [CMS_WorkflowHistory] WHERE VersionHistoryID IN (
        SELECT VersionHistoryID FROM [CMS_VersionHistory] WHERE NodeSiteID = @SiteID
    );

    -- deletes user cultures
    DELETE FROM [CMS_UserCulture] WHERE SiteID=@SiteID;
    -- deletes site's VersionHistory
    DELETE FROM [CMS_VersionHistory] WHERE NodeSiteID=@SiteID;
    -- deletes site's SettingKeys
    DELETE FROM [CMS_SettingsKey] WHERE SiteID=@SiteID;
    -- deletes site's EmailTemplates
    DELETE FROM [CMS_EmailTemplate] WHERE EmailTemplateSiteID=@SiteID;
    -- deletes site's DomainAliases
    DELETE FROM [CMS_SiteDomainAlias] WHERE SiteID=@SiteID;
    -- deletes site's cultures
    DELETE FROM [CMS_SiteCulture] WHERE SiteID=@SiteID;
    -- deletes site's PageTemplates
    -- declare temporary templates table
	DECLARE @templateTable TABLE (
		PageTemplateID int NOT NULL
	);	
	-- get the all templates to be deleted 
	INSERT INTO @templateTable SELECT PageTemplateID FROM CMS_PageTemplate WHERE (PageTemplateID IN (SELECT PageTemplateID FROM CMS_PageTemplateSite WHERE SiteID = @SiteID ) OR PageTemplateSiteID = @SiteID) GROUP BY PageTemplateID HAVING COUNT(PageTemplateID) = 1
	
	-- delete pagetemplate <-> site bindings
    DELETE FROM [CMS_PageTemplateSite] WHERE SiteID=@SiteID;
    -- delete page templates that are not used anywhere else
    DELETE FROM [CMS_PageTemplate] WHERE PageTemplateSiteID=@SiteID AND PageTemplateID IN (SELECT * FROM @templateTable);
    -- deletes site's Users
    DELETE FROM [CMS_UserSite] WHERE SiteID=@SiteID;
    -- removes Role's dependences when site's Roles are deleted
    DELETE FROM [Forums_ForumRoles ] WHERE RoleID IN (
        SELECT RoleID FROM [CMS_Role] WHERE SiteID = @SiteID
    );
    DELETE FROM [CMS_UserRole] WHERE RoleID IN (
        SELECT RoleID FROM [CMS_Role] WHERE SiteID=@SiteID
    );
    DELETE FROM [CMS_RolePermission] WHERE RoleID IN (
        SELECT RoleID FROM [CMS_Role] WHERE SiteID=@SiteID
    );
    DELETE FROM [CMS_RoleUIElement] WHERE RoleID IN (
        SELECT RoleID FROM [CMS_Role] WHERE SiteID=@SiteID
    );
    DELETE FROM [CMS_WorkflowStepRoles] WHERE RoleID IN (
        SELECT RoleID FROM [CMS_Role] WHERE SiteID=@SiteID
    );
    DELETE FROM [Polls_PollRoles] WHERE RoleID IN (
        SELECT RoleID FROM [CMS_Role] WHERE SiteID = @SiteID
    );
    DELETE FROM [CMS_FormRole] WHERE RoleID IN (
        SELECT RoleID FROM [CMS_Role] WHERE SiteID=@SiteID
    );
    DELETE FROM [Community_GroupRolePermission] WHERE RoleID IN (
        SELECT RoleID FROM [CMS_Role] WHERE SiteID = @SiteID
    );
	DELETE FROM [Media_LibraryRolePermission] WHERE RoleID IN (
        SELECT RoleID FROM [CMS_Role] WHERE SiteID = @SiteID
    );
    DELETE FROM [CMS_WidgetRole] WHERE RoleID IN (
        SELECT RoleID FROM [CMS_Role] WHERE SiteID = @SiteID
    );
    DELETE FROM [PM_ProjectRolePermission] WHERE ProjectID IN (
		SELECT ProjectID FROM PM_Project WHERE ProjectSiteID = @SiteID
	);
    
    -- deletes site's Roles
    DELETE FROM [CMS_Role] WHERE SiteID=@SiteID;
    -- deletes site's Resources
    DELETE FROM [CMS_ResourceSite] WHERE SiteID=@SiteID;
    -- deletes site's Classes
    DELETE FROM [CMS_ClassSite] WHERE SiteID=@SiteID;
    -- deletes Events of the site
    DELETE FROM [CMS_EventLog] WHERE SiteID=@SiteID;
    -- deletes site's RelationshipNames
    DELETE FROM [CMS_RelationshipNameSite] WHERE SiteID=@SiteID;
    -- deletes site's WorkflowScopes
    DELETE FROM [CMS_WorkflowScope] WHERE ScopeSiteID=@SiteID;
    -- deletes site's CSSStylesheets
    DELETE FROM CMS_CssStylesheetSite WHERE SiteID=@SiteID;
    -- deletes site's InlineControls
    DELETE FROM [CMS_InlineControlSite] WHERE SiteID=@SiteID;
    -- deletes site's ScheduledTasks
    DELETE FROM [CMS_ScheduledTask] WHERE TaskSiteID=@SiteID;


    -- deletes site's WebPart containers
    DELETE FROM CMS_WebPartContainerSite WHERE SiteID=@SiteID;
    -- deletes site Polls and site's assignment to Polls
    DELETE FROM [Polls_PollRoles] WHERE PollID IN (
            SELECT PollID FROM [Polls_Poll] WHERE PollSiteID = @SiteID
        );
    DELETE FROM [Polls_PollSite] WHERE SiteID = @SiteID;
    DELETE FROM [Polls_PollAnswer] WHERE AnswerPollID IN (
            SELECT PollID FROM [Polls_Poll] WHERE PollSiteID = @SiteID
        );
    DELETE FROM [Polls_Poll] WHERE PollSiteID = @SiteID;
    
    -- removes Newsletter_Subscriber's dependences when site's Newsletter_Subscribers are deleted
    DELETE FROM [Newsletter_Emails] WHERE EmailSubscriberID IN (
        SELECT SubscriberID FROM [Newsletter_Subscriber] WHERE SubscriberSiteID=@SiteID
    );
    DELETE FROM [Newsletter_SubscriberNewsletter] WHERE SubscriberID IN (
        SELECT SubscriberID FROM [Newsletter_Subscriber] WHERE SubscriberSiteID=@SiteID
    );
    -- deletes site's Newsletter_Subscribers
    DELETE FROM [Newsletter_Subscriber] WHERE SubscriberSiteID=@SiteID;
    -- removes Newsletter_Newsletter's dependences when site's Newsletter_Newsletters are deleted
    DELETE FROM [Newsletter_Emails] WHERE EmailNewsletterIssueID IN (
        SELECT IssueID FROM [Newsletter_NewsletterIssue] WHERE IssueNewsletterID IN (
            SELECT NewsletterID FROM [Newsletter_Newsletter] WHERE NewsletterSiteID=@SiteID
        )
    );
    DELETE FROM [Newsletter_NewsletterIssue] WHERE IssueNewsletterID IN (
        SELECT NewsletterID FROM [Newsletter_Newsletter] WHERE NewsletterSiteID=@SiteID
    );
    DELETE FROM [Newsletter_SubscriberNewsletter] WHERE NewsletterID IN (
        SELECT NewsletterID FROM [Newsletter_Newsletter] WHERE NewsletterSiteID=@SiteID
    );
    -- deletes site's Newsletter_Newsletters
    DELETE FROM [Newsletter_Newsletter] WHERE NewsletterSiteID=@SiteID;
    -- removes Newsletter_EmailTemplate's dependences when site's Newsletter_EmailTemplates are deleted
    DELETE FROM [Newsletter_Emails] WHERE EmailNewsletterIssueID IN (
        SELECT IssueID FROM [Newsletter_NewsletterIssue] WHERE IssueTemplateID IN (
            SELECT TemplateID FROM [Newsletter_EmailTemplate] WHERE TemplateSiteID=@SiteID
        )
    );
    DELETE FROM [Newsletter_NewsletterIssue] WHERE IssueTemplateID IN (
            SELECT TemplateID FROM [Newsletter_EmailTemplate] WHERE TemplateSiteID=@SiteID
    );
    -- deletes site's Newsletter_EmailTemplates
    DELETE FROM [Newsletter_EmailTemplate] WHERE TemplateSiteID=@SiteID;
    -- removes CMS_Class's dependences when BizForms are deleted
    DELETE FROM [CMS_Query] WHERE ClassID IN (
        SELECT FormClassID FROM [CMS_Form] WHERE FormSiteID=@SiteID
    );
    -- insert ClassIDs of BizForms into the temporaty table
    DECLARE @classIdTable TABLE (
        FormClassID int
    );
    -- get the classes
    INSERT INTO @classIdTable SELECT FormClassID FROM [CMS_Form] WHERE FormSiteID=@SiteID;
    -- deletes site's BizForms' roles from CMS_Form
    DELETE FROM [CMS_FormRole] WHERE FormID IN (SELECT FormID FROM [CMS_Form] WHERE FormSiteID=@SiteID);
    -- deletes site's BizForms' alt.forms from CMS_AlternativeForm
    DELETE FROM [CMS_AlternativeForm] WHERE FormClassID IN (SELECT FormClassID FROM @classIdTable)
        OR FormCoupledClassID IN (SELECT FormClassID FROM @classIdTable);
    -- deletes site's BizForms from CMS_Form
    DELETE FROM [CMS_Form] WHERE FormSiteID=@SiteID;
    -- deletes BizForms' records in CMS_Class
    DELETE FROM [CMS_Class] WHERE ClassID IN (SELECT FormClassID FROM @classIdTable);
    
    -- FORUM
    -- Forum user favorites
    DELETE FROM [Forums_UserFavorites] WHERE SiteID = @SiteID;
    -- Forum attachment
    DELETE FROM [Forums_Attachment] WHERE AttachmentSiteID = @SiteID;
    
    UPDATE [Forums_ForumPost]  SET PostParentID=NULL WHERE PostForumId IN (
        SELECT ForumID FROM [Forums_Forum] WHERE ForumGroupID IN (
        SELECT GroupID FROM [Forums_ForumGroup] WHERE GroupSiteID = @SiteID
        ));
    DELETE FROM [Forums_ForumSubscription] WHERE SubscriptionForumId IN (
        SELECT ForumID FROM [Forums_Forum] WHERE ForumGroupID  IN (
        SELECT GroupID FROM [Forums_ForumGroup] WHERE GroupSiteID = @SiteID)
    );
    DELETE FROM [Forums_ForumPost] WHERE PostForumId IN (
        SELECT ForumID FROM [Forums_Forum] WHERE ForumGroupID IN (
        SELECT GroupID FROM [Forums_ForumGroup] WHERE GroupSiteID = @SiteID)
    );
    DELETE FROM [Forums_ForumRoles ] WHERE ForumId IN (
        SELECT ForumID FROM [Forums_Forum] WHERE ForumGroupID IN (
        SELECT GroupID FROM [Forums_ForumGroup] WHERE GroupSiteID = @SiteID)
    );
    DELETE FROM [Forums_ForumModerators] WHERE ForumID IN (
        SELECT ForumID FROM [Forums_Forum] WHERE ForumGroupID  IN (
        SELECT GroupID FROM [Forums_ForumGroup] WHERE GroupSiteID = @SiteID)
    );
    
    DELETE FROM [Forums_Forum] WHERE ForumGroupId  IN (
        SELECT GroupID FROM [Forums_ForumGroup] WHERE GroupSiteID = @SiteID);    
    DELETE FROM [Forums_ForumGroup] WHERE GroupSiteID = @SiteID;
    -- delete Staging dependences
    DELETE FROM [Staging_Synchronization] WHERE 
        SynchronizationTaskID IN (SELECT TaskID FROM [Staging_Task] WHERE TaskSiteID = @SiteID)
        OR
        SynchronizationServerID IN (SELECT ServerID FROM [Staging_Server] WHERE ServerSiteID = @SiteID)
    ;
    DELETE FROM [Staging_SyncLog] WHERE 
        SyncLogTaskID IN (SELECT TaskID FROM [Staging_Task] WHERE TaskSiteID = @SiteID)
        OR 
        SyncLogServerID IN (SELECT ServerID FROM [Staging_Server] WHERE ServerSiteID = @SiteID)
    ;
    DELETE FROM [Staging_Server] WHERE ServerSiteID = @SiteID;
    -- delete StagingTasks
    DELETE FROM [Staging_Task] WHERE TaskSiteID = @SiteID;
    -- ECOMMERCE
    -- delete COM_ShoppingCart dependences
    DELETE FROM [COM_ShoppingCartSKU] WHERE ShoppingCartID IN (
        SELECT ShoppingCartID FROM [COM_ShoppingCart] WHERE ShoppingCartSiteID = @SiteID
    );
    -- delete COM_ShoppingCart
    DELETE FROM [COM_ShoppingCart] WHERE ShoppingCartSiteID = @SiteID;
    -- delete COM_Order dependences
    DELETE FROM [COM_OrderStatusUser] WHERE OrderID IN (
        SELECT OrderID FROM [COM_Order] WHERE OrderSiteID = @SiteID
    );
    DELETE FROM [COM_OrderItem] WHERE OrderItemOrderID IN (
        SELECT OrderID FROM [COM_Order] WHERE OrderSiteID = @SiteID
    );
    -- delete COM_Order
    DELETE FROM [COM_Order] WHERE OrderSiteID = @SiteID;
    -- delete COM_ShippingOption dependences
    DELETE FROM [COM_ShoppingCart] WHERE ShoppingCartShippingOptionID IN (
        SELECT ShippingOptionID FROM [COM_ShippingOption] WHERE ShippingOptionSiteID = @SiteID
    );
    UPDATE [COM_Customer] SET CustomerPreferredShippingOptionID=NULL WHERE CustomerPreferredShippingOptionID IN (
        SELECT ShippingOptionID FROM [COM_ShippingOption] WHERE ShippingOptionSiteID = @SiteID
    );
    DELETE FROM [COM_PaymentShipping] WHERE ShippingOptionID IN (
        SELECT ShippingOptionID FROM [COM_ShippingOption] WHERE ShippingOptionSiteID = @SiteID
    );
    -- delete COM_ShippingOption
    DELETE FROM [COM_ShippingOption] WHERE ShippingOptionSiteID = @SiteID;
    -- delete COM_PaymentOption dependences
    DELETE FROM [COM_ShoppingCart] WHERE ShoppingCartPaymentOptionID IN (
        SELECT PaymentOptionID FROM [COM_PaymentOption] WHERE PaymentOptionSiteID = @SiteID
    );
    UPDATE [COM_Customer] SET CustomerPrefferedPaymentOptionID=NULL WHERE CustomerPrefferedPaymentOptionID IN (
        SELECT PaymentOptionID FROM [COM_PaymentOption] WHERE PaymentOptionSiteID = @SiteID
    );
    DELETE FROM [COM_PaymentShipping] WHERE PaymentOptionID IN (
        SELECT PaymentOptionID FROM [COM_PaymentOption] WHERE PaymentOptionSiteID = @SiteID
    );
    -- delete COM_PaymentOption
    DELETE FROM [COM_PaymentOption] WHERE PaymentOptionSiteID = @SiteID;
    -- delete items from COM_Wishlist
    DELETE FROM [COM_Wishlist] WHERE SiteID = @SiteID;
    -- WEB ANALYTICS
    -- delete Analytics_Statistics dependences
    DELETE FROM Analytics_DayHits WHERE HitsStatisticsID IN (
        SELECT StatisticsID FROM Analytics_Statistics WHERE StatisticsSiteID=@SiteID);
    DELETE FROM Analytics_HourHits WHERE HitsStatisticsID IN (
        SELECT StatisticsID FROM Analytics_Statistics WHERE StatisticsSiteID=@SiteID);
    DELETE FROM Analytics_MonthHits WHERE HitsStatisticsID IN (
        SELECT StatisticsID FROM Analytics_Statistics WHERE StatisticsSiteID=@SiteID);
    DELETE FROM Analytics_WeekHits WHERE HitsStatisticsID IN (
        SELECT StatisticsID FROM Analytics_Statistics WHERE StatisticsSiteID=@SiteID);
    DELETE FROM Analytics_YearHits WHERE HitsStatisticsID IN (
        SELECT StatisticsID FROM Analytics_Statistics WHERE StatisticsSiteID=@SiteID);
    -- delete Analytics_Statistics
    DELETE FROM Analytics_Statistics WHERE StatisticsSiteID = @SiteID;
    -- POLLS
    DELETE FROM Polls_PollSite WHERE SiteID = @SiteID;
    -- Metafiles
    DELETE FROM CMS_MetaFile WHERE MetaFileSiteID = @SiteID;
    -- Export history
    DELETE FROM Export_History WHERE ExportSiteID = @SiteID;
    DELETE FROM Export_Task WHERE TaskSiteID = @SiteID;
    -- Notifications
    DELETE FROM Notification_Subscription WHERE SubscriptionTemplateID IN (SELECT TemplateID FROM Notification_Template WHERE TemplateSiteID = @SiteID);
    DELETE FROM Notification_TemplateText WHERE Notification_TemplateText.TemplateID IN (SELECT TemplateID FROM Notification_Template WHERE TemplateSiteID = @SiteID);
    DELETE FROM Notification_Template WHERE TemplateSiteID = @SiteID;
    DELETE FROM Notification_Subscription WHERE SubscriptionSiteID = @SiteID;
    -- Media libraries
    DELETE FROM Media_LibraryRolePermission WHERE LibraryID IN (SELECT Media_Library.LibraryID FROM Media_Library WHERE LibrarySiteID = @SiteID);
    DELETE FROM Media_File WHERE FileLibraryID IN (SELECT Media_Library.LibraryID FROM Media_Library WHERE LibrarySiteID = @SiteID);
    DELETE FROM Media_Library WHERE LibrarySiteID = @SiteID;
    -- Message boards
    DELETE FROM [Board_Message] WHERE MessageBoardID IN (SELECT BoardID FROM [Board_Board] WHERE BoardSiteID = @SiteID);
	DELETE FROM [Board_Moderator] WHERE BoardID IN (SELECT BoardID FROM [Board_Board] WHERE BoardSiteID = @SiteID);
    DELETE FROM [Board_Role] WHERE BoardID IN (SELECT BoardID FROM [Board_Board] WHERE BoardSiteID = @SiteID);
    DELETE FROM [Board_Subscription] WHERE SubscriptionBoardID IN (SELECT BoardID FROM [Board_Board] WHERE BoardSiteID = @SiteID);
    DELETE FROM [Board_Board] WHERE BoardSiteID = @SiteID;
    -- Delete Tags
    DELETE FROM [CMS_Tag] WHERE TagGroupID  IN (
        SELECT TagGroupID FROM [CMS_TagGroup] WHERE TagGroupSiteID = @SiteID);    
    DELETE FROM [CMS_TagGroup] WHERE TagGroupSiteID = @SiteID;
    
    -- Project Management
    UPDATE [PM_Project] SET ProjectGroupID = NULL WHERE ProjectGroupID IN (
        SELECT GroupID FROM [Community_Group] WHERE GroupSiteID = @SiteID
    );
    
    -- Groups
    DELETE FROM [Community_GroupMember] WHERE MemberGroupID IN (
        SELECT GroupID FROM [Community_Group] WHERE GroupSiteID = @SiteID
    );
	DELETE FROM [Community_Invitation] WHERE InvitationGroupID IN (
        SELECT GroupID FROM [Community_Group] WHERE GroupSiteID = @SiteID
    );
    DELETE FROM [Community_Group] WHERE GroupSiteID = @SiteID;
    -- Report abuse
    DELETE FROM [CMS_AbuseReport] WHERE ReportSiteID = @SiteID;
    -- Banned IPs
    DELETE FROM [CMS_BannedIP] WHERE IPAddressSiteID = @SiteID;
    -- User sessions
    DELETE FROM [CMS_Session] WHERE SessionSiteID = @SiteID;
    -- search index
    DELETE FROM [CMS_SearchIndexSite] WHERE IndexSiteID = @SiteID;
    
    -- CMS Page template scopes
    DELETE FROM [CMS_PageTemplateScope] WHERE PageTemplateScopeSiteID = @SiteID;
    
    -- Project Management
    DELETE FROM [PM_ProjectTask] WHERE ProjectTaskProjectID IN (
		SELECT ProjectID FROM PM_Project WHERE ProjectSiteID = @SiteID
	);
    DELETE FROM [PM_Project] WHERE ProjectSiteID = @SiteID;
    
END
GO

UPDATE [CMS_WebPart]
SET [WebPartProperties] = '<form><category name="Filter" /><field column="XmlUrl" fieldcaption="XML URL" visible="true" columntype="text" fieldtype="textbox" allowempty="false" isPK="false" system="false" columnsize="1000" publicfield="false" spellcheck="true" guid="ff78149f-086d-42ac-9a53-01b484021433" fielddescription="{$documentation.webpartproperties.xmlurl$}" visibility="none" ismacro="false" /><field column="XmlSchemaUrl" fieldcaption="XML custom XSD schema URL" visible="true" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="1000" publicfield="false" spellcheck="true" guid="abe12e95-e708-4107-b3ce-b312ef0884b4" visibility="none" ismacro="false" fielddescription="URL of the XML custom XSD schema." /><field column="TableName" fieldcaption="Table name" visible="true" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="50" fielddescription="More complex XML creates dataset with more tables. Specify the name of table which will be used as datasource." publicfield="false" spellcheck="true" guid="5a044d1a-fa4f-4820-ad83-69bb0d1372de" visibility="none" /><field column="OrderBy" fieldcaption="ORDER BY expression" visible="true" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="500" fielddescription="{$documentation.webpartproperties.orderby$}" publicfield="false" spellcheck="true" guid="5edffe02-f7ad-4194-b86e-4f2dcdcd0a33" /><field column="SelectTopN" fieldcaption="Select Top N items" visible="true" columntype="integer" fieldtype="textbox" allowempty="true" isPK="false" system="false" fielddescription="{$documentation.webpartproperties.selecttopn$}" publicfield="false" spellcheck="true" guid="e639bae0-3cc9-4272-a055-537e0b4dabb7" /><field column="WhereCondition" fieldcaption="WHERE condition" visible="true" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="500" fielddescription="{$documentation.webpartproperties.where$}" publicfield="false" spellcheck="true" guid="0a8bef6b-160d-41d5-9886-9f0cfe7bb31e" /><field column="FilterName" fieldcaption="Filter name" visible="true" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="{$documentation.webpartproperties.filtername$}" publicfield="false" spellcheck="true" guid="56fb7924-53df-4b44-9789-84c0977d84b5" /><category name="System settings" /><field column="CacheItemName" fieldcaption="Cache item name" visible="true" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="{$documentation.webpartproperties.cacheitemname$}" publicfield="false" spellcheck="true" guid="17abcad8-5e99-4355-a121-ba6bf63e5459" /><field column="CacheMinutes" fieldcaption="Cache minutes" visible="true" columntype="integer" fieldtype="textbox" allowempty="true" isPK="false" system="false" fielddescription="{$documentation.webpartproperties.cacheminutes$}" publicfield="false" spellcheck="true" guid="1eaab89d-56d9-4bae-9adc-f316c81f49b3" /><field column="CacheDependencies" fieldcaption="Cache dependencies" visible="true" columntype="longtext" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" fielddescription="{$documentation.webpartproperties.cachedependencies$}" publicfield="false" spellcheck="true" guid="e538e91e-dbdd-4d10-aec8-51acfc3760d3" visibility="none"><settings><controlname>cachedependencies</controlname></settings></field></form>'
WHERE [WebPartName]='xmldatasource'
GO

/* ----------------------------------------------------------------------------*/
/* This SQL command must be at the end and must contain current hotfix version */
/* ----------------------------------------------------------------------------*/
UPDATE [CMS_SettingsKey] SET KeyValue = '12' WHERE KeyName = N'CMSHotfixVersion'
GO
